#import "ArmyAnt.h"
#import "MyObject.h"
#import <space.h>
#import <objectbase/Swarm.h>

@interface AAntModelSwarm: Swarm
{
  int numAAnts; // liczba mrwek
  int aantDetectZone; // promie strefy czucia mrwek
  int aantCallZone; // strefa nawoywania mrwek
  int minAAntNum; // minimalna liczba mrwek potrzebna do przesunicia adunku

  int numObjects; // liczba przedmiotw
  int objectZone; // promie strefy wykrywania przedmiotw

  int worldXSize, worldYSize; // rozmiar wiata

  int dumpSize; // rozmiar boku kwadratu - mietnika
  int dumpX, dumpY; // miejsce mietnika

  int callPriority; // waga wanoci sygnau nawoywa
  int goingToObjectPriority; // waga wanoci podania do przedmiotu

  int avoidLastStepFlag; // jeeli jest ustawiona zabrania mrwce cofania si
  int immediatelyCall; // jeeli jest ustawiona mrwki powiadomione o przedmiocie natychmiast
                       // woaj inne (bez czekania na swoj kolejk)

  double antActivity;
  long allSteps;

  id <ActionGroup> modelActions;
  id <Schedule> modelSchedule;
  id actionForEach;

  id <List> completeList;
  id <List> aantList;
  id <List> objectList;
  id <Grid2d> world;

  Color dumpColor;
}

- getCompleteList;
- getAAntList;
- getObjectList;
- (id <Grid2d>)getWorld;
- setDumpColor: (Color)c;
- drawDump: (id <ZoomRaster>) worldRaster;
- (double)getAverageActivity;

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;

@end

